import pymysql
from flask_marshmallow import Marshmallow
from marshmallow import fields, Schema
from sqlalchemy import Column, ForeignKey, Integer, String, BigInteger, TIMESTAMP, text, Boolean, TEXT, TIME, DATE, Float
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relationship,scoped_session,sessionmaker
from sqlalchemy import create_engine
from flask_login import UserMixin
import configparser
from marshmallow_sqlalchemy import ModelSchema


config = configparser.ConfigParser()
config.read('config.ini')

dbhost = config['DATABASE']['IP']
dbuser = config['DATABASE']['USERNAME']
dbpass = config['DATABASE']['PASSWORD']
dbname = config['DATABASE']['DB']
dbport = int(config['DATABASE']['PORT'])
Base = declarative_base()


class Users(Base,UserMixin):
    __tablename__='users'
    id = Column(BigInteger,primary_key=True)
    username = Column(String(50),nullable=False)
    email = Column(String(50),nullable=False,unique=True)
    phone = Column(BigInteger,nullable=False)
    password = Column(String(150),nullable=False)
    role = Column(String(20), nullable=True)
    speciality = Column(String(50), nullable=True)
    dateofsub = Column(TIMESTAMP,server_default=text('CURRENT_TIMESTAMP'),nullable=True)

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)

class Activitylog(Base):
    __tablename__ = 'activitylog'
    id = Column(BigInteger, primary_key=True)
    user_id = Column(BigInteger, ForeignKey('users.id'))
    user = relationship("Users", lazy='joined')
    activity = Column(String(60), nullable=False)
    ts = Column(TIMESTAMP,server_default=text('CURRENT_TIMESTAMP'),nullable=True)

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)

class BreastPatient(Base):
    __tablename__ = 'BreastPatient'
    id = Column(BigInteger, primary_key=True)
    pid = Column(BigInteger, nullable=False,unique=True)
    date = Column(DATE,nullable=True)
    # month & year for dashboard graph
    month = Column(String(10), nullable=True)
    year = Column(String(10), nullable=True)

    code = Column(String(50), nullable=False)
    place = Column(String(60), nullable=False)
    pname = Column(String(60), nullable=False)
    fhname = Column(String(30), nullable=False)
    age = Column(Integer, nullable=False)
    sex  = Column(String(10), nullable=False)
    education  = Column(String(40), nullable=False)
    address = Column(String(250), nullable=False)
    phone = Column(BigInteger, nullable=False)
    district = Column(String(30), nullable=False)
    state = Column(String(25), nullable=False)
    area = Column(String(30), nullable=False)
    referred_by = Column(String(40), nullable=False,default="None")
    occupation = Column(String(40), nullable=False)
    ethnic = Column(String(30), nullable=False)
    marital_status = Column(String(30), nullable=False)
    marital_status_years = Column(BigInteger, nullable=False,default="0")
    menses_frequency = Column(String(20), nullable=False)
    menses_loss = Column(String(20), nullable=False)
    menarche_years = Column(BigInteger, nullable=False,default="0")
    hystrectomy = Column(String(15), nullable=False)
    hystrectomy_years = Column(BigInteger, nullable=False,default="0")
    menopause = Column(String(15), nullable=False)
    menopause_years = Column(BigInteger, nullable=False,default="0")
    children = Column(Integer, nullable=False)
    children_male = Column(Integer, nullable=False,default="0")
    children_female = Column(Integer, nullable=False,default="0")
    abortions = Column(String(15), nullable=False)
    abortions_number = Column(Integer, nullable=False,default="0")
    abortions_cause = Column(String(25), nullable=False,default="nil")
    breastfed = Column(String(15), nullable=False)
    breastfed_years = Column(Integer, nullable=False,default="0")
    current_lactation = Column(String(15), nullable=False)
    contraception_methods = Column(String(15), nullable=False)
    contraception_methods_type = Column(String(25), nullable=False,default="nil")
    hormone_treatment = Column(String(15), nullable=False)
    addiction = Column(String(20), nullable=False,default="nil")
    tobacco = Column(String(15), nullable=False)
    tobacco_years = Column(Integer, nullable=False,default="0")
    smoking = Column(String(15), nullable=False)
    smoking_years = Column(Integer, nullable=False,default="0")
    alcohol = Column(String(15), nullable=False)
    alcohol_years = Column(Integer, nullable=False, default="0")
    family_history = Column(String(50), nullable=False)
    comorbidities = Column(String(50), nullable=False)
    breastlump = Column(String(15), nullable=False)
    breastlump_location = Column(String(50), nullable=False)
    breastlump_size = Column(String(30), nullable=False)
    overlying_skin = Column(String(50), nullable=False)
    axillarylump = Column(String(30), nullable=False)
    axillarylump_side = Column(String(15), nullable=False)
    matted = Column(String(10), nullable=False)
    axillarylump_size = Column(String(35), nullable=False)
    nipple_discharge = Column(String(15), nullable=False)
    nipple_discharge_frequency = Column(String(25), nullable=False)
    nipple_discharge_colour = Column(String(25), nullable=False)
    mastalgia = Column(String(35), nullable=False)
    mastitis = Column(String(35), nullable=False)
    ulcer = Column(String(35), nullable=False)
    nipple_inversion = Column(String(35), nullable=False)
    others = Column(String(50), nullable=False)
    duration = Column(String(25), nullable=False)
    pasthistory = Column(String(50), nullable=False)
    surgical_history = Column(String(50), nullable=False)
    drug_history = Column(String(50), nullable=False)
    drug_allergy = Column(String(15), nullable=False)
    drug_allergy_type = Column(String(40), nullable=True)
    bowelhabit = Column(String(25), nullable=False)
    bladderhabit = Column(String(25), nullable=False)
    sleep = Column(String(20), nullable=False)
    appetite = Column(String(50), nullable=False)
#examination
    weight = Column(Integer, nullable=False)
    height = Column(Integer, nullable=False)
    bmi = Column(String(30), nullable=False)
    bp = Column(Integer, nullable=False)
    pulse = Column(Integer, nullable=False)
    temp = Column(String(25), nullable=False)
    respiratory_rate = Column(Integer, nullable=False)
    health_condition = Column(String(50), nullable=False)
    examination_remarks = Column(String(50), nullable=False)
    bra_size = Column(String(150), nullable=False)
# investigations
    usg = Column(String(50), nullable=True)
    mmg = Column(String(50), nullable=True)
    mri = Column(String(50), nullable=True)
    fnac = Column(String(50), nullable=True)
    core_biopsy = Column(String(50), nullable=True)
    incision_biopsy = Column(String(50), nullable=True)
    investigation_remarks = Column(String(50), nullable=True)
    blood_investigation = Column(String(250), nullable=True)
    diagnosis = Column(String(50), nullable=True)
    treatment_plan = Column(String(50), nullable=True)

    user_id = Column(BigInteger, ForeignKey('users.id'))
    user = relationship("Users")

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)

class UsersSchema(Schema):
    id = fields.Int(dump_only=True)
    username = fields.Str()
    email = fields.Str()
    phone = fields.Int()
    password = fields.Str()
    role = fields.Str()
    speciality = fields.Str()
    dateofsub = fields.Str()

    class Meta:
        model = Users


class ActivitySchema(Schema):
    id = fields.Int(dump_only=True)
    user_id = fields.Int(dump_only=True)
    activity = fields.Str()
    ts = fields.Str()
    user = fields.Nested(UsersSchema)



class BPatientSchema(Schema):
    pid = fields.Int()
    date = fields.Str()
    code = fields.Str()
    place =fields.Str()
    pname = fields.Str()
    fhname = fields.Str()
    age = fields.Int()
    sex = fields.Str()
    education = fields.Str()
    address = fields.Str()
    phone = fields.Int()
    district = fields.Str()
    state = fields.Str()
    area = fields.Str()
    referred_by = fields.Str()
    occupation = fields.Str()
    ethnic = fields.Str()
    marital_status = fields.Str()
    marital_status_years = fields.Int()
    menses_frequency = fields.Str()
    menses_loss = fields.Str()
    menarche_years = fields.Int()
    hystrectomy = fields.Str()
    hystrectomy_years = fields.Int()
    menopause = fields.Str()
    menopause_years = fields.Int()
    children = fields.Int()
    children_male = fields.Int()
    children_female = fields.Int()
    abortions = fields.Str()
    abortions_number = fields.Int()
    abortions_cause = fields.Str()
    breastfed = fields.Str()
    breastfed_years = fields.Int()
    current_lactation = fields.Str()
    contraception_methods = fields.Str()
    contraception_methods_type = fields.Str()
    hormone_treatment = fields.Str()
    addiction = fields.Str()
    tobacco = fields.Str()
    tobacco_years = fields.Int()
    smoking = fields.Str()
    smoking_years = fields.Int()
    alcohol = fields.Str()
    alcohol_years = fields.Int()
    family_history = fields.Str()
    comorbidities = fields.Str()
    breastlump = fields.Str()
    breastlump_location = fields.Str()
    breastlump_size = fields.Str()
    overlying_skin = fields.Str()
    axillarylump = fields.Str()
    axillarylump_side = fields.Str()
    matted = fields.Str()
    axillarylump_size = fields.Str()
    nipple_discharge = fields.Str()
    nipple_discharge_frequency = fields.Str()
    nipple_discharge_colour = fields.Str()
    mastalgia = fields.Str()
    mastitis = fields.Str()
    ulcer = fields.Str()
    nipple_inversion = fields.Str()
    others = fields.Str()
    duration = fields.Str()
    pasthistory = fields.Str()
    surgical_history = fields.Str()
    drug_history = fields.Str()
    drug_allergy = fields.Str()
    drug_allergy_type = fields.Str()
    bowelhabit = fields.Str()
    bladderhabit = fields.Str()
    sleep = fields.Str()
    appetite = fields.Str()
    # examination
    weight = fields.Int()
    height = fields.Int()
    bmi = fields.Str()
    bp =fields.Int()
    pulse = fields.Int()
    temp = fields.Str()
    respiratory_rate = fields.Int()
    health_condition =fields.Str()
    examination_remarks = fields.Str()
    bra_size = fields.Str()
    # investigations
    usg = fields.Str()
    mmg = fields.Str()
    mri = fields.Str()
    fnac = fields.Str()
    core_biopsy = fields.Str()
    incision_biopsy = fields.Str()
    investigation_remarks = fields.Str()
    blood_investigation = fields.Str()
    diagnosis = fields.Str()
    treatment_plan = fields.Str()
    user = fields.Nested(UsersSchema)


class RheumatologyPatient(Base):
    __tablename__ = 'RheumatologyPatient'
    id = Column(BigInteger, primary_key=True)
    pid = Column(BigInteger, nullable=False,unique=True)
    date = Column(DATE,nullable=True)
    # month & year for dashboard graph
    month = Column(String(10), nullable=True)
    year = Column(String(10), nullable=True)

    code = Column(String(50), nullable=False)
    place = Column(String(60), nullable=False)
    pname = Column(String(60), nullable=False)
    fhname = Column(String(30), nullable=False)
    age = Column(Integer, nullable=False)
    sex  = Column(String(10), nullable=False)
    education  = Column(String(40), nullable=False)
    address = Column(String(250), nullable=False)
    phone = Column(BigInteger, nullable=False)
    district = Column(String(30), nullable=False)
    state = Column(String(25), nullable=False)
    area = Column(String(30), nullable=False)
    referred_by = Column(String(40), nullable=False,default="None")
    occupation = Column(String(40), nullable=False)
    ethnic = Column(String(30), nullable=False)
    marital_status = Column(String(30), nullable=False)
    marital_status_years = Column(BigInteger, nullable=False,default="0")
    menses_frequency = Column(String(20), nullable=False)
    menses_loss = Column(String(20), nullable=False)
    menarche_years = Column(BigInteger, nullable=False,default="0")
    hysterectomy = Column(String(15), nullable=False)
    hysterectomy_years = Column(BigInteger, nullable=False,default="0")
    menopause = Column(String(15), nullable=False)
    menopause_years = Column(BigInteger, nullable=False,default="0")
    children =  Column(Integer, nullable=False)
    children_male = Column(Integer, nullable=False,default="0")
    children_female = Column(Integer, nullable=False,default="0")
    abortions = Column(String(15), nullable=False)
    abortions_number = Column(Integer, nullable=False,default="0")
    abortions_cause = Column(String(25), nullable=True,default="nil")
    current_lactation = Column(String(15), nullable=True)
    contraception_methods = Column(String(15), nullable=True)
    contraception_methods_type = Column(String(25), nullable=False,default="nil")
    hormone_treatment = Column(String(15), nullable=False)
    addiction = Column(String(20), nullable=True,default="nil")
    tobacco = Column(String(15), nullable=True)
    tobacco_years = Column(Integer, nullable=False,default=0)
    smoking = Column(String(15), nullable=True)
    smoking_years = Column(Integer, nullable=False,default=0)
    alcohol = Column(String(15), nullable=True)
    alcohol_years = Column(Integer, nullable=False, default=0)
    family_history = Column(String(50), nullable=True)
    health_condition = Column(String(50), nullable=True)
    remarks = Column(String(50), nullable=True)
    comorbidities = Column(String(50), nullable=True)
    #COMPLAINTS
    onset = Column(String(50), nullable=True)
    onset_duration = Column(String(50), nullable=True)
    onset_duration_type = Column(String(50), nullable=True)
    first_symptom=Column(String(50), nullable=True)
    initial_site_joint=Column(String(50), nullable=True)
    soft_tissue=Column(String(50), nullable=True)
    others=Column(String(50), nullable=True)
    course1=Column(String(50), nullable=True)
    course2=Column(String(50), nullable=True)
    pattern1=Column(String(50), nullable=True)
    pattern2=Column(String(50), nullable=True)
    current_relapse=Column(String(50), nullable=True)
    current_relapse_type=Column(String(50), nullable=True)
    detailed_history=Column(String(100), nullable=True)
    pasthistory = Column(String(50), nullable=True)
    surgical_history = Column(String(50), nullable=True)
    drug_history = Column(String(50), nullable=True)
    drug_allergy = Column(String(15), nullable=True)
    drug_allergy_type = Column(String(40), nullable=True)
    bowelhabit = Column(String(25), nullable=True)
    sleep = Column(String(20), nullable=True)

    user_id = Column(BigInteger, ForeignKey('users.id'))
    user = relationship("Users")

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)


class RheumatologyPatientExamination(Base):
    __tablename__ = 'RheumatologyPatientExamination'
    id = Column(BigInteger, primary_key=True)
    # EXAMINATION
    general_condition = Column(String(50), nullable=True)
    weight = Column(Integer, nullable=True)
    height = Column(Integer, nullable=True)
    bmi = Column(String(30), nullable=True)
    # vitals
    bp = Column(Integer, nullable=True)
    pulse = Column(Integer, nullable=True)
    temp = Column(String(25), nullable=True)
    respiratory_rate = Column(Integer, nullable=True)
    ex_health_condition = Column(String(50), nullable=True)
    ex_remarks = Column(String(50), nullable=True)
    eyes = Column(String(50), nullable=True)
    skin_morphology = Column(String(50), nullable=True)
    skin_pattern = Column(String(50), nullable=True)
    skin_color = Column(String(50), nullable=True)
    distribution = Column(String(50), nullable=True)
    other_affects = Column(String(50), nullable=True)
    mucosa = Column(String(50), nullable=True)
    hair_loss = Column(String(50), nullable=True)
    dandruff = Column(String(20), nullable=True)
    nail = Column(String(50), nullable=True)
    lymphnodes = Column(String(50), nullable=True)
    lymphnodes_number = Column(String(50), nullable=True)
    tender = Column(String(20), nullable=True)
    tender_type = Column(String(20), nullable=True)
    lymphnodes_tender_others = Column(String(50), nullable=True)
    vascular = Column(String(50), nullable=True)
    cns_examination = Column(String(50), nullable=True)
    cvs_examination = Column(String(50), nullable=True)
    chest_examination = Column(String(50), nullable=True)
    abdomen_examination = Column(String(50), nullable=True)
    # MUSCULOSKELETAL_EXAMINATIONS
    # joint_evaluation:
    # row1

    tm_t1 = Column(String(10), nullable=True)
    tm_s1 = Column(String(10), nullable=True)
    tm_t2 = Column(String(10), nullable=True)
    tm_s2 = Column(String(10), nullable=True)
    scl_t1 = Column(String(10), nullable=True)
    scl_s1 = Column(String(10), nullable=True)
    scl_t2 = Column(String(10), nullable=True)
    scl_s2 = Column(String(10), nullable=True)
    acl_t1 = Column(String(10), nullable=True)
    acl_s1 = Column(String(10), nullable=True)
    acl_t2 = Column(String(10), nullable=True)
    acl_s2 = Column(String(10), nullable=True)
    sh_t1 = Column(String(10), nullable=True)
    sh_s1 = Column(String(10), nullable=True)
    sh_t2 = Column(String(10), nullable=True)
    sh_s2 = Column(String(10), nullable=True)
    elbow_t1 = Column(String(10), nullable=True)
    elbow_s1 = Column(String(10), nullable=True)
    elbow_t2 = Column(String(10), nullable=True)
    elbow_s2 = Column(String(10), nullable=True)
    infru_t1 = Column(String(10), nullable=True)
    infru_s1 = Column(String(10), nullable=True)
    infru_t2 = Column(String(10), nullable=True)
    infru_s2 = Column(String(10), nullable=True)
    cmc1_t1 = Column(String(10), nullable=True)
    cmc1_s1 = Column(String(10), nullable=True)
    cmc1_t2 = Column(String(10), nullable=True)
    cmc1_s2 = Column(String(10), nullable=True)
    wrist_t1 = Column(String(10), nullable=True)
    wrist_s1 = Column(String(10), nullable=True)
    wrist_t2 = Column(String(10), nullable=True)
    wrist_s2 = Column(String(10), nullable=True)
    dip2_t1 = Column(String(10), nullable=True)
    dip2_s1 = Column(String(10), nullable=True)
    dip2_t2 = Column(String(10), nullable=True)
    dip2_s2 = Column(String(10), nullable=True)
    dip3_t1 = Column(String(10), nullable=True)
    dip3_s1 = Column(String(10), nullable=True)
    dip3_t2 = Column(String(10), nullable=True)
    dip3_s2 = Column(String(10), nullable=True)
    dip4_t1 = Column(String(10), nullable=True)
    dip4_s1 = Column(String(10), nullable=True)
    dip4_t2 = Column(String(10), nullable=True)
    dip4_s2 = Column(String(10), nullable=True)
    dip5_t1 = Column(String(10), nullable=True)
    dip5_s1 = Column(String(10), nullable=True)
    dip5_t2 = Column(String(10), nullable=True)
    dip5_s2 = Column(String(10), nullable=True)
    ip1_t1 = Column(String(10), nullable=True)
    ip1_s1 = Column(String(10), nullable=True)
    ip1_t2 = Column(String(10), nullable=True)
    ip1_s2 = Column(String(10), nullable=True)
    ip2_t1 = Column(String(10), nullable=True)
    ip2_s1 = Column(String(10), nullable=True)
    ip2_t2 = Column(String(10), nullable=True)
    ip2_s2 = Column(String(10), nullable=True)
    pip3_t1 = Column(String(10), nullable=True)
    pip3_s1 = Column(String(10), nullable=True)
    pip3_t2 = Column(String(10), nullable=True)
    pip3_s2 = Column(String(10), nullable=True)
    pip4_t1 = Column(String(10), nullable=True)
    pip4_s1 = Column(String(10), nullable=True)
    pip4_t2 = Column(String(10), nullable=True)
    pip4_s2 = Column(String(10), nullable=True)
    pip5_t1 = Column(String(10), nullable=True)
    pip5_s1 = Column(String(10), nullable=True)
    pip5_t2 = Column(String(10), nullable=True)
    pip5_s2 = Column(String(10), nullable=True)
    mcp1_t1 = Column(String(10), nullable=True)
    mcp1_s1 = Column(String(10), nullable=True)
    mcp1_t2 = Column(String(10), nullable=True)
    mcp1_s2 = Column(String(10), nullable=True)
    mcp2_t1 = Column(String(10), nullable=True)
    mcp2_s1 = Column(String(10), nullable=True)
    mcp2_t2 = Column(String(10), nullable=True)
    mcp2_s2 = Column(String(10), nullable=True)

    # row2
    mcp3_t1 = Column(String(10), nullable=True)
    mcp3_s1 = Column(String(10), nullable=True)
    mcp3_t2 = Column(String(10), nullable=True)
    mcp3_s2 = Column(String(10), nullable=True)
    mcp4_t1 = Column(String(10), nullable=True)
    mcp4_s1 = Column(String(10), nullable=True)
    mcp4_t2 = Column(String(10), nullable=True)
    mcp4_s2 = Column(String(10), nullable=True)
    mcp5_t1 = Column(String(10), nullable=True)
    mcp5_s1 = Column(String(10), nullable=True)
    mcp5_t2 = Column(String(10), nullable=True)
    mcp5_s2 = Column(String(10), nullable=True)
    hip_t1 = Column(String(10), nullable=True)
    hip_s1 = Column(String(10), nullable=True)
    hip_t2 = Column(String(10), nullable=True)
    hip_s2 = Column(String(10), nullable=True)
    knee_t1 = Column(String(10), nullable=True)
    knee_s1 = Column(String(10), nullable=True)
    knee_t2 = Column(String(10), nullable=True)
    knee_s2 = Column(String(10), nullable=True)
    a_tt_t1 = Column(String(10), nullable=True)
    a_tt_s1 = Column(String(10), nullable=True)
    a_tt_t2 = Column(String(10), nullable=True)
    a_tt_s2 = Column(String(10), nullable=True)
    a_tc_t1 = Column(String(10), nullable=True)
    a_tc_s1 = Column(String(10), nullable=True)
    a_tc_t2 = Column(String(10), nullable=True)
    a_tc_s2 = Column(String(10), nullable=True)
    mtl_t1 = Column(String(10), nullable=True)
    mtl_s1 = Column(String(10), nullable=True)
    mtl_t2 = Column(String(10), nullable=True)
    mtl_s2 = Column(String(10), nullable=True)
    mtp1_t1 = Column(String(10), nullable=True)
    mtp1_s1 = Column(String(10), nullable=True)
    mtp1_t2 = Column(String(10), nullable=True)
    mtp1_s2 = Column(String(10), nullable=True)
    mtp2_t1 = Column(String(10), nullable=True)
    mtp2_s1 = Column(String(10), nullable=True)
    mtp2_t2 = Column(String(10), nullable=True)
    mtp2_s2 = Column(String(10), nullable=True)
    mtp3_t1 = Column(String(10), nullable=True)
    mtp3_s1 = Column(String(10), nullable=True)
    mtp3_t2 = Column(String(10), nullable=True)
    mtp3_s2 = Column(String(10), nullable=True)
    mtp4_t1 = Column(String(10), nullable=True)
    mtp4_s1 = Column(String(10), nullable=True)
    mtp4_t2 = Column(String(10), nullable=True)
    mtp4_s2 = Column(String(10), nullable=True)
    mtp5_t1 = Column(String(10), nullable=True)
    mtp5_s1 = Column(String(10), nullable=True)
    mtp5_t2 = Column(String(10), nullable=True)
    mtp5_s2 = Column(String(10), nullable=True)
    ip1b_t1 = Column(String(10), nullable=True)
    ip1b_s1 = Column(String(10), nullable=True)
    ip1b_t2 = Column(String(10), nullable=True)
    ip1b_s2 = Column(String(10), nullable=True)
    ip2b_t1 = Column(String(10), nullable=True)
    ip2b_s1 = Column(String(10), nullable=True)
    ip2b_t2 = Column(String(10), nullable=True)
    ip2b_s2 = Column(String(10), nullable=True)
    ip3b_t1 = Column(String(10), nullable=True)
    ip3b_s1 = Column(String(10), nullable=True)
    ip3b_t2 = Column(String(10), nullable=True)
    ip3b_s2 = Column(String(10), nullable=True)
    ip4b_t1 = Column(String(10), nullable=True)
    ip4b_s1 = Column(String(10), nullable=True)
    ip4b_t2 = Column(String(10), nullable=True)
    ip4b_s2 = Column(String(10), nullable=True)
    ip5b_t1 = Column(String(10), nullable=True)
    ip5b_s1 = Column(String(10), nullable=True)
    ip5b_t2 = Column(String(10), nullable=True)
    ip5b_s2 = Column(String(10), nullable=True)
    s1_t1 = Column(String(10), nullable=True)
    s1_s1 = Column(String(10), nullable=True)
    s1_t2 = Column(String(10), nullable=True)
    s1_s2 = Column(String(10), nullable=True)
    # ROM
    cervical_anky = Column(String(10), nullable=True)
    cervical_flex = Column(String(10), nullable=True)
    cervical_ext = Column(String(10), nullable=True)
    cervical_rtrot = Column(String(10), nullable=True)
    cervical_ltrot = Column(String(10), nullable=True)
    cervical_rtfl = Column(String(10), nullable=True)
    cervical_ltfl = Column(String(10), nullable=True)
    cervical_pt = Column(String(10), nullable=True)
    thorasic_anky = Column(String(10), nullable=True)
    thorasic_flex = Column(String(10), nullable=True)
    thorasic_ext = Column(String(10), nullable=True)
    thorasic_rtrot = Column(String(10), nullable=True)
    thorasic_ltrot = Column(String(10), nullable=True)
    thorasic_rtfl = Column(String(10), nullable=True)
    thorasic_ltfl = Column(String(10), nullable=True)
    thorasic_pt = Column(String(10), nullable=True)
    lumbar_anky = Column(String(10), nullable=True)
    lumbar_flex = Column(String(10), nullable=True)
    lumbar_ext = Column(String(10), nullable=True)
    lumbar_rtrot = Column(String(10), nullable=True)
    lumbar_ltrot = Column(String(10), nullable=True)
    lumbar_rtfl = Column(String(10), nullable=True)
    lumbar_ltfl = Column(String(10), nullable=True)
    lumbar_pt = Column(String(10), nullable=True)
    # SOFT TISSUE RHEUMATISM
    opt_rt = Column(String(10), nullable=True)
    opt_lt = Column(String(10), nullable=True)
    lcer_rt = Column(String(10), nullable=True)
    lcer_lt = Column(String(10), nullable=True)
    trpz_rt = Column(String(10), nullable=True)
    trpz_lt = Column(String(10), nullable=True)
    scap_rt = Column(String(10), nullable=True)
    scap_lt = Column(String(10), nullable=True)
    zcst_rt = Column(String(10), nullable=True)
    zcst_lt = Column(String(10), nullable=True)
    epdl_rt = Column(String(10), nullable=True)
    epdl_lt = Column(String(10), nullable=True)
    glut_rt = Column(String(10), nullable=True)
    glut_lt = Column(String(10), nullable=True)
    trcr_rt = Column(String(10), nullable=True)
    trcr_lt = Column(String(10), nullable=True)
    knee_rt = Column(String(10), nullable=True)
    knee_lt = Column(String(10), nullable=True)
    ta_rt = Column(String(10), nullable=True)
    ta_lt = Column(String(10), nullable=True)
    calf_rt = Column(String(10), nullable=True)
    calf_lt = Column(String(10), nullable=True)
    sole_rt = Column(String(10), nullable=True)
    sole_lt = Column(String(10), nullable=True)
    # DEFORMITIES
    # joints  #last column is missing from image
    rhand_fl = Column(String(10), nullable=True)
    rhand_ex = Column(String(10), nullable=True)
    rhand_ab = Column(String(10), nullable=True)
    rhand_add = Column(String(10), nullable=True)
    rhand_slx = Column(String(10), nullable=True)
    lhand_fl = Column(String(10), nullable=True)
    lhand_ex = Column(String(10), nullable=True)
    lhand_ab = Column(String(10), nullable=True)
    lhand_add = Column(String(10), nullable=True)
    lhand_slx = Column(String(10), nullable=True)
    rwrist_fl = Column(String(10), nullable=True)
    rwrist_ex = Column(String(10), nullable=True)
    rwrist_ab = Column(String(10), nullable=True)
    rwrist_add = Column(String(10), nullable=True)
    rwrist_slx = Column(String(10), nullable=True)
    lwrist_fl = Column(String(10), nullable=True)
    lwrist_ex = Column(String(10), nullable=True)
    lwrist_ab = Column(String(10), nullable=True)
    lwrist_add = Column(String(10), nullable=True)
    lwrist_slx = Column(String(10), nullable=True)
    relb_fl = Column(String(10), nullable=True)
    relb_ex = Column(String(10), nullable=True)
    relb_ab = Column(String(10), nullable=True)
    relb_add = Column(String(10), nullable=True)
    relb_slx = Column(String(10), nullable=True)
    lelb_fl = Column(String(10), nullable=True)
    lelb_ex = Column(String(10), nullable=True)
    lelb_ab = Column(String(10), nullable=True)
    lelb_add = Column(String(10), nullable=True)
    lelb_slx = Column(String(10), nullable=True)
    shrt_fl = Column(String(10), nullable=True)
    shrt_ex = Column(String(10), nullable=True)
    shrt_ab = Column(String(10), nullable=True)
    shrt_add = Column(String(10), nullable=True)
    shrt_slx = Column(String(10), nullable=True)
    shlt_fl = Column(String(10), nullable=True)
    shlt_ex = Column(String(10), nullable=True)
    shlt_ab = Column(String(10), nullable=True)
    shlt_add = Column(String(10), nullable=True)
    shlt_slx = Column(String(10), nullable=True)
    kneert_fl = Column(String(10), nullable=True)
    kneert_ex = Column(String(10), nullable=True)
    kneert_ab = Column(String(10), nullable=True)
    kneert_add = Column(String(10), nullable=True)
    kneert_slx = Column(String(10), nullable=True)
    kneelt_fl = Column(String(10), nullable=True)
    kneelt_ex = Column(String(10), nullable=True)
    kneelt_ab = Column(String(10), nullable=True)
    kneelt_add = Column(String(10), nullable=True)
    kneelt_slx = Column(String(10), nullable=True)
    footrt_fl = Column(String(10), nullable=True)
    footrt_ex = Column(String(10), nullable=True)
    footrt_ab = Column(String(10), nullable=True)
    footrt_add = Column(String(10), nullable=True)
    footrt_slx = Column(String(10), nullable=True)
    footlt_fl = Column(String(10), nullable=True)
    footlt_ex = Column(String(10), nullable=True)
    footlt_ab = Column(String(10), nullable=True)
    footlt_add = Column(String(10), nullable=True)
    footlt_slx = Column(String(10), nullable=True)
    # HYPERMOBILITY
    thumb_rt = Column(String(10), nullable=True)
    thumb_lt = Column(String(10), nullable=True)
    finger_rt = Column(String(10), nullable=True)
    finger_lt = Column(String(10), nullable=True)
    palm_rt = Column(String(10), nullable=True)
    palm_lt = Column(String(10), nullable=True)
    elbow_rt = Column(String(10), nullable=True)
    elbow_lt = Column(String(10), nullable=True)
    hy_knee_rt = Column(String(10), nullable=True)
    hy_knee_lt = Column(String(10), nullable=True)
    ankle_rt = Column(String(10), nullable=True)
    ankle_lt = Column(String(10), nullable=True)
    other_rt = Column(String(10), nullable=True)
    other_lt = Column(String(10), nullable=True)
    spine_rt = Column(String(10), nullable=True)
    spine_lt = Column(String(10), nullable=True)

    pid = Column(BigInteger, ForeignKey('RheumatologyPatient.pid'), unique=True)
    rheumatologypatient = relationship("RheumatologyPatient")

    user_id = Column(BigInteger, ForeignKey('users.id'))
    user = relationship("Users")

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)

class RheumatologyPatientInvestigation(Base):
    __tablename__ = 'RheumatologyPatientInvestigation'
    id = Column(BigInteger,primary_key=True)
    # INVESTIGATIONS #table
    hematological_date = Column(String(20), nullable=True)
    hem_esr = Column(String(20), nullable=True)
    hem_hb = Column(String(20), nullable=True)
    hem_tlc = Column(String(20), nullable=True)
    hem_pleb = Column(String(20), nullable=True)
    hem_plat = Column(String(20), nullable=True)
    hem_urine = Column(String(20), nullable=True)
    hem_others = Column(String(40), nullable=True)
    # 2column investigation
    hematological_date2 = Column(String(20), nullable=True)
    hem_esr2 = Column(String(20), nullable=True)
    hem_hb2 = Column(String(20), nullable=True)
    hem_tlc2 = Column(String(20), nullable=True)
    hem_pleb2 = Column(String(20), nullable=True)
    hem_plat2 = Column(String(20), nullable=True)
    hem_urine2 = Column(String(20), nullable=True)
    hem_others2 = Column(String(40), nullable=True)
    # 3column investigation
    hematological_date3 = Column(String(20), nullable=True)
    hem_esr3 = Column(String(20), nullable=True)
    hem_hb3 = Column(String(20), nullable=True)
    hem_tlc3 = Column(String(20), nullable=True)
    hem_pleb3 = Column(String(20), nullable=True)
    hem_plat3 = Column(String(20), nullable=True)
    hem_urine3 = Column(String(20), nullable=True)
    hem_others3 = Column(String(40), nullable=True)
    # 4column investigation
    hematological_date4 = Column(String(20), nullable=True)
    hem_esr4 = Column(String(20), nullable=True)
    hem_hb4 = Column(String(20), nullable=True)
    hem_tlc4 = Column(String(20), nullable=True)
    hem_pleb4 = Column(String(20), nullable=True)
    hem_plat4 = Column(String(20), nullable=True)
    hem_urine4 = Column(String(20), nullable=True)
    hem_others4 = Column(String(40), nullable=True)
    # 5column investigation
    hematological_date5 = Column(String(20), nullable=True)
    hem_esr5 = Column(String(20), nullable=True)
    hem_hb5 = Column(String(20), nullable=True)
    hem_tlc5 = Column(String(20), nullable=True)
    hem_pleb5 = Column(String(20), nullable=True)
    hem_plat5 = Column(String(20), nullable=True)
    hem_urine5 = Column(String(20), nullable=True)
    hem_others5 = Column(String(40), nullable=True)
    # table2
    biochemical_date = Column(String(20), nullable=True)
    bio_lft = Column(String(20), nullable=True)
    bio_rft = Column(String(20), nullable=True)
    bio_crp = Column(String(20), nullable=True)
    bio_bsl = Column(String(20), nullable=True)
    bio_ua = Column(String(20), nullable=True)
    bio_others = Column(String(40), nullable=True)
    # 2column investigation biochemical
    biochemical_date2 = Column(String(20), nullable=True)
    bio_lft2 = Column(String(20), nullable=True)
    bio_rft2 = Column(String(20), nullable=True)
    bio_crp2 = Column(String(20), nullable=True)
    bio_bsl2 = Column(String(20), nullable=True)
    bio_ua2 = Column(String(20), nullable=True)
    bio_others2 = Column(String(40), nullable=True)
    # 3 column investigation biochemical
    biochemical_date3 = Column(String(20), nullable=True)
    bio_lft3 = Column(String(20), nullable=True)
    bio_rft3 = Column(String(20), nullable=True)
    bio_crp3 = Column(String(20), nullable=True)
    bio_bsl3 = Column(String(20), nullable=True)
    bio_ua3 = Column(String(20), nullable=True)
    bio_others3 = Column(String(40), nullable=True)
    # 4 column investigation biochemical
    biochemical_date4 = Column(String(20), nullable=True)
    bio_lft4 = Column(String(20), nullable=True)
    bio_rft4 = Column(String(20), nullable=True)
    bio_crp4 = Column(String(20), nullable=True)
    bio_bsl4 = Column(String(20), nullable=True)
    bio_ua4 = Column(String(20), nullable=True)
    bio_others4 = Column(String(40), nullable=True)
    # 5 column investigation biochemical
    biochemical_date5 = Column(String(20), nullable=True)
    bio_lft5 = Column(String(20), nullable=True)
    bio_rft5 = Column(String(20), nullable=True)
    bio_crp5 = Column(String(20), nullable=True)
    bio_bsl5 = Column(String(20), nullable=True)
    bio_ua5 = Column(String(20), nullable=True)
    bio_others5 = Column(String(40), nullable=True)

    # table3
    immunological_date = Column(String(20), nullable=True)
    imm_rf = Column(String(20), nullable=True)
    imm_accp = Column(String(20), nullable=True)
    imm_ana = Column(String(20), nullable=True)
    imm_anawb = Column(String(20), nullable=True)
    imm_ace = Column(String(20), nullable=True)
    imm_dsdna = Column(String(20), nullable=True)
    imm_hlab27 = Column(String(20), nullable=True)
    imm_c3 = Column(String(20), nullable=True)
    imm_c4 = Column(String(20), nullable=True)
    imm_others = Column(String(40), nullable=True)
    # 2 column investigation immunological
    immunological_date2 = Column(String(20), nullable=True)
    imm_rf2 = Column(String(20), nullable=True)
    imm_accp2 = Column(String(20), nullable=True)
    imm_ana2 = Column(String(20), nullable=True)
    imm_anawb2 = Column(String(20), nullable=True)
    imm_ace2 = Column(String(20), nullable=True)
    imm_dsdna2 = Column(String(20), nullable=True)
    imm_hlab272 = Column(String(20), nullable=True)
    imm_c32 = Column(String(20), nullable=True)
    imm_c42 = Column(String(20), nullable=True)
    imm_others2 = Column(String(40), nullable=True)

    # 3 column investigation immunological
    immunological_date3 = Column(String(20), nullable=True)
    imm_rf3 = Column(String(20), nullable=True)
    imm_accp3 = Column(String(20), nullable=True)
    imm_ana3 = Column(String(20), nullable=True)
    imm_anawb3 = Column(String(20), nullable=True)
    imm_ace3 = Column(String(20), nullable=True)
    imm_dsdna3 = Column(String(20), nullable=True)
    imm_hlab273 = Column(String(20), nullable=True)
    imm_c33 = Column(String(20), nullable=True)
    imm_c43 = Column(String(20), nullable=True)
    imm_others3 = Column(String(40), nullable=True)

    # Radiological
    usg = Column(String(40), nullable=True)
    xray_chest = Column(String(40), nullable=True)
    xray_joints = Column(String(40), nullable=True)
    mri = Column(String(40), nullable=True)
    radio_remarks = Column(String(50), nullable=True)

    # Disease activity indices
    das28 = Column(String(20), nullable=True)
    sledai = Column(String(20), nullable=True)
    basdai = Column(String(20), nullable=True)
    pasi = Column(String(20), nullable=True)
    bvas = Column(String(20), nullable=True)
    mrss = Column(String(20), nullable=True)
    sdai_cdai = Column(String(20), nullable=True)
    asdas = Column(String(20), nullable=True)
    dapsa = Column(String(20), nullable=True)
    vdi = Column(String(20), nullable=True)
    essdai = Column(String(20), nullable=True)

    # HEALTH_ASSESSMENT_QUESTIONNAIRE :
    # are you able to
    # dressing
    can_u_dress_urself = Column(String(10), nullable=True)
    can_u_wash_ur_hair = Column(String(10), nullable=True)
    can_u_comb_ur_hair = Column(String(10), nullable=True)
    dressing_score = Column(Integer, nullable=True)
    # arising
    can_u_stand_from_chair = Column(String(10), nullable=True)
    can_u_get_inout_from_bed = Column(String(10), nullable=True)
    can_u_sit_grossteg_onfloor = Column(String(10), nullable=True)
    arising_score = Column(Integer, nullable=True)
    # eating
    can_u_cut_vegetables = Column(String(10), nullable=True)
    can_u_lift_glass = Column(String(10), nullable=True)
    can_u_break_roti_from_1hand = Column(String(10), nullable=True)
    eating_score = Column(Integer, nullable=True)
    # walking
    can_u_walk = Column(String(10), nullable=True)
    can_u_climb_5steps = Column(String(10), nullable=True)
    walking_score = Column(Integer, nullable=True)
    # hygiene
    can_u_take_bath = Column(String(10), nullable=True)
    can_u_wash_dry_urbody = Column(String(10), nullable=True)
    can_u_get_onoff_toilet = Column(String(10), nullable=True)
    hygiene_score = Column(Integer, nullable=True)
    # reaching
    can_u_weigh_2kg = Column(String(10), nullable=True)
    can_u_bend_and_pickcloths = Column(String(10), nullable=True)
    reaching_score = Column(Integer, nullable=True)
    # grip
    can_u_open_bottle = Column(String(10), nullable=True)
    can_u_turntaps_onoff = Column(String(10), nullable=True)
    can_u_open_latches = Column(String(10), nullable=True)
    grip_score = Column(Integer, nullable=True)
    # activities
    can_u_work_office_house = Column(String(10), nullable=True)
    can_u_run_errands = Column(String(10), nullable=True)
    can_u_get_inout_of_bus = Column(String(10), nullable=True)
    activities_score = Column(Integer, nullable=True)
    # modified CRD pune version HAQ score
    # on a scale of 10 cm
    patient_assessment_pain = Column(BigInteger, nullable=True)
    grip_strength_rt = Column(BigInteger, nullable=True)
    grip_strength_hg = Column(BigInteger, nullable=True)
    grip_strength_lt = Column(BigInteger, nullable=True)
    early_mrng_stiffness = Column(BigInteger, nullable=True)
    assess_sleep = Column(String(20), nullable=True)
    general_health_assessment = Column(Integer, nullable=True)
    # summary(history+examination+investigation)
    classification_criteria_followig = Column(String(10), nullable=True)
    diagnosis = Column(String(40), nullable=True)
    treatment_plan = Column(String(350), nullable=True)


    pid = Column(BigInteger, ForeignKey('RheumatologyPatient.pid'), unique=True)
    rheumatologypatient = relationship("RheumatologyPatient")

    # peid = Column(BigInteger, ForeignKey('RheumatologyPatientExamination.pid'), nullable=True)
    # rheumatologypatientexamination = relationship("RheumatologyPatientExamination")

    user_id = Column(BigInteger, ForeignKey('users.id'))
    user = relationship("Users")

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)


# got a new way to do the hard work
class RheumatologyPatientSchema(ModelSchema):
    class Meta:
        # fields = ("pid","pname","age","date")
        model = RheumatologyPatient
        include_fk = True

    user = fields.Nested(UsersSchema)


# got a new way to do the hard work
class RheumatologyPatientExaminationSchema(ModelSchema):
    class Meta:
        # fields = ("pid","pname","age","date")
        model = RheumatologyPatientExamination
        include_fk = True

    user = fields.Nested(UsersSchema)
    rheumatologypatient = fields.Nested(RheumatologyPatientSchema)


# got a new way to do the hard work
class RheumatologyPatientInvestigationSchema(ModelSchema):
    class Meta:
        # fields = ("pid","pname","age","date")
        model = RheumatologyPatientInvestigation
        include_fk = True


    user = fields.Nested(UsersSchema)
    rheumatologypatient = fields.Nested(RheumatologyPatientSchema)




class RheumatologyFollowup(Base):
    __tablename__ = 'RheumatologyFollowup'
    id = Column(BigInteger, primary_key=True)
    pid = Column(BigInteger, ForeignKey('RheumatologyPatient.pid'))
    code = Column(String(50), nullable=True)
    date = Column(DATE,nullable=True)
    #month & year for dashboard graph
    month = Column(String(10), nullable=True)
    year = Column(String(10), nullable=True)
    pname = Column(String(60), nullable=True)
    age = Column(Integer, nullable=True)
    sex = Column(String(10), nullable=True)
    address = Column(String(250), nullable=True)
    phone = Column(BigInteger, nullable=True)
    firstvisit = Column(String(20), nullable=True)
    lastvisit = Column(String(20), nullable=True)
    timelapsed = Column(String(20), nullable=True)
    bp = Column(Integer, nullable=True)
    wt = Column(Integer, nullable=True)
    followup = Column(String(20), nullable=True)
    course_result = Column(String(25), nullable=True)
    improved_percent = Column(BigInteger, nullable=True, default="0")
    deteriorate_percent = Column(BigInteger, nullable=True, default="0")
    history = Column(String(100), nullable=True)
    diagnosis = Column(String(50), nullable=True)
    addnewdiagnosis = Column(String(50), nullable=True)
    # Toxicity table
    # adverseeffects

    anorexia = Column(String(10), nullable=True)
    anorexia_duration = Column(String(50), nullable=True)
    anorexia_severity = Column(String(30), nullable=True)
    anorexia_cause = Column(String(40), nullable=True)
    nausea = Column(String(10), nullable=True)
    nausea_duration = Column(String(50), nullable=True)
    nausea_severity = Column(String(30), nullable=True)
    nausea_cause = Column(String(40), nullable=True)
    vomiting = Column(String(10), nullable=True)
    vomiting_duration = Column(String(50), nullable=True)
    vomiting_severity = Column(String(30), nullable=True)
    vomiting_cause = Column(String(40), nullable=True)
    acidity = Column(String(10), nullable=True)
    acidity_duration = Column(String(50), nullable=True)
    acidity_severity = Column(String(30), nullable=True)
    acidity_cause = Column(String(40), nullable=True)
    pain_abdomen = Column(String(10), nullable=True)
    pain_duration = Column(String(50), nullable=True)
    pain_severity = Column(String(30), nullable=True)
    pain_cause = Column(String(40), nullable=True)
    diarrhoea = Column(String(10), nullable=True)
    diarrhoea_duration = Column(String(50), nullable=True)
    diarrhoea_severity = Column(String(30), nullable=True)
    diarrhoea_cause = Column(String(40), nullable=True)
    oral_ulcers = Column(String(10), nullable=True)
    ulcers_duration = Column(String(50), nullable=True)
    ulcers_severity = Column(String(30), nullable=True)
    ulcers_cause = Column(String(40), nullable=True)
    constipation = Column(String(10), nullable=True)
    constipation_duration = Column(String(50), nullable=True)
    constipation_severity = Column(String(30), nullable=True)
    constipation_cause = Column(String(40), nullable=True)
    skinrash = Column(String(10), nullable=True)
    skinrash_duration = Column(String(50), nullable=True)
    skinrash_severity = Column(String(30), nullable=True)
    skinrash_cause = Column(String(40), nullable=True)
    hairfall = Column(String(10), nullable=True)
    hairfall_duration = Column(String(50), nullable=True)
    hairfall_severity = Column(String(30), nullable=True)
    hairfall_cause = Column(String(40), nullable=True)
    othertoxics = Column(String(10), nullable=True)
    othertoxics_duration = Column(String(50), nullable=True)
    othertoxics_severity = Column(String(30), nullable=True)
    othertoxics_cause = Column(String(40), nullable=True)

    # Drugs begin on
    hcq = Column(String(30), nullable=True)
    mtx = Column(String(30), nullable=True)
    ssz = Column(String(30), nullable=True)
    lef = Column(String(30), nullable=True)
    azt = Column(String(30), nullable=True)
    mmf = Column(String(30), nullable=True)
    pred = Column(String(30), nullable=True)
    nsaid = Column(String(30), nullable=True)

    # table
    esr = Column(String(10), nullable=True)
    hb = Column(String(10), nullable=True)
    tlc = Column(String(10), nullable=True)
    dlc = Column(String(10), nullable=True)
    platelet = Column(String(10), nullable=True)
    urine = Column(String(10), nullable=True)
    bun = Column(String(10), nullable=True)
    cr = Column(String(10), nullable=True)
    sgot = Column(String(10), nullable=True)
    sgpt = Column(String(10), nullable=True)
    alb = Column(String(10), nullable=True)
    glob = Column(String(10), nullable=True)
    ua = Column(String(10), nullable=True)
    bsl = Column(String(10), nullable=True)
    rf = Column(String(10), nullable=True)
    crp = Column(String(10), nullable=True)
    bili = Column(String(10), nullable=True)
    other = Column(String(40), nullable=True)
    xray = Column(String(50), nullable=True)
    treatment_plan = Column(String(250), nullable=True)

    # joint_evaluation:
    # row1
    tm_t1 = Column(String(10), nullable=True)
    tm_s1 = Column(String(10), nullable=True)
    tm_t2 = Column(String(10), nullable=True)
    tm_s2 = Column(String(10), nullable=True)
    scl_t1 = Column(String(10), nullable=True)
    scl_s1 = Column(String(10), nullable=True)
    scl_t2 = Column(String(10), nullable=True)
    scl_s2 = Column(String(10), nullable=True)
    acl_t1 = Column(String(10), nullable=True)
    acl_s1 = Column(String(10), nullable=True)
    acl_t2 = Column(String(10), nullable=True)
    acl_s2 = Column(String(10), nullable=True)
    sh_t1 = Column(String(10), nullable=True)
    sh_s1 = Column(String(10), nullable=True)
    sh_t2 = Column(String(10), nullable=True)
    sh_s2 = Column(String(10), nullable=True)
    elbow_t1 = Column(String(10), nullable=True)
    elbow_s1 = Column(String(10), nullable=True)
    elbow_t2 = Column(String(10), nullable=True)
    elbow_s2 = Column(String(10), nullable=True)
    infru_t1 = Column(String(10), nullable=True)
    infru_s1 = Column(String(10), nullable=True)
    infru_t2 = Column(String(10), nullable=True)
    infru_s2 = Column(String(10), nullable=True)
    cmc1_t1 = Column(String(10), nullable=True)
    cmc1_s1 = Column(String(10), nullable=True)
    cmc1_t2 = Column(String(10), nullable=True)
    cmc1_s2 = Column(String(10), nullable=True)
    wrist_t1 = Column(String(10), nullable=True)
    wrist_s1 = Column(String(10), nullable=True)
    wrist_t2 = Column(String(10), nullable=True)
    wrist_s2 = Column(String(10), nullable=True)
    dip2_t1 = Column(String(10), nullable=True)
    dip2_s1 = Column(String(10), nullable=True)
    dip2_t2 = Column(String(10), nullable=True)
    dip2_s2 = Column(String(10), nullable=True)
    dip3_t1 = Column(String(10), nullable=True)
    dip3_s1 = Column(String(10), nullable=True)
    dip3_t2 = Column(String(10), nullable=True)
    dip3_s2 = Column(String(10), nullable=True)
    dip4_t1 = Column(String(10), nullable=True)
    dip4_s1 = Column(String(10), nullable=True)
    dip4_t2 = Column(String(10), nullable=True)
    dip4_s2 = Column(String(10), nullable=True)
    dip5_t1 = Column(String(10), nullable=True)
    dip5_s1 = Column(String(10), nullable=True)
    dip5_t2 = Column(String(10), nullable=True)
    dip5_s2 = Column(String(10), nullable=True)
    r1ip1_t1 = Column(String(10), nullable=True)
    r1ip1_s1 = Column(String(10), nullable=True)
    r1ip1_t2 = Column(String(10), nullable=True)
    r1ip1_s2 = Column(String(10), nullable=True)
    r1ip2_t1 = Column(String(10), nullable=True)
    r1ip2_s1 = Column(String(10), nullable=True)
    r1ip2_t2 = Column(String(10), nullable=True)
    r1ip2_s2 = Column(String(10), nullable=True)
    pip3_t1 = Column(String(10), nullable=True)
    pip3_s1 = Column(String(10), nullable=True)
    pip3_t2 = Column(String(10), nullable=True)
    pip3_s2 = Column(String(10), nullable=True)
    pip4_t1 = Column(String(10), nullable=True)
    pip4_s1 = Column(String(10), nullable=True)
    pip4_t2 = Column(String(10), nullable=True)
    pip4_s2 = Column(String(10), nullable=True)
    pip5_t1 = Column(String(10), nullable=True)
    pip5_s1 = Column(String(10), nullable=True)
    pip5_t2 = Column(String(10), nullable=True)
    pip5_s2 = Column(String(10), nullable=True)
    mcp1_t1 = Column(String(10), nullable=True)
    mcp1_s1 = Column(String(10), nullable=True)
    mcp1_t2 = Column(String(10), nullable=True)
    mcp1_s2 = Column(String(10), nullable=True)
    mcp2_t1 = Column(String(10), nullable=True)
    mcp2_s1 = Column(String(10), nullable=True)
    mcp2_t2 = Column(String(10), nullable=True)
    mcp2_s2 = Column(String(10), nullable=True)

    # row2

    mcp3_t1 = Column(String(10), nullable=True)
    mcp3_s1 = Column(String(10), nullable=True)
    mcp3_t2 = Column(String(10), nullable=True)
    mcp3_s2 = Column(String(10), nullable=True)
    mcp4_t1 = Column(String(10), nullable=True)
    mcp4_s1 = Column(String(10), nullable=True)
    mcp4_t2 = Column(String(10), nullable=True)
    mcp4_s2 = Column(String(10), nullable=True)
    mcp5_t1 = Column(String(10), nullable=True)
    mcp5_s1 = Column(String(10), nullable=True)
    mcp5_t2 = Column(String(10), nullable=True)
    mcp5_s2 = Column(String(10), nullable=True)
    hip_t1 = Column(String(10), nullable=True)
    hip_s1 = Column(String(10), nullable=True)
    hip_t2 = Column(String(10), nullable=True)
    hip_s2 = Column(String(10), nullable=True)
    knee_t1 = Column(String(10), nullable=True)
    knee_s1 = Column(String(10), nullable=True)
    knee_t2 = Column(String(10), nullable=True)
    knee_s2 = Column(String(10), nullable=True)
    a_tt_t1 = Column(String(10), nullable=True)
    a_tt_s1 = Column(String(10), nullable=True)
    a_tt_t2 = Column(String(10), nullable=True)
    a_tt_s2 = Column(String(10), nullable=True)
    a_tc_t1 = Column(String(10), nullable=True)
    a_tc_s1 = Column(String(10), nullable=True)
    a_tc_t2 = Column(String(10), nullable=True)
    a_tc_s2 = Column(String(10), nullable=True)
    mtl_t1 = Column(String(10), nullable=True)
    mtl_s1 = Column(String(10), nullable=True)
    mtl_t2 = Column(String(10), nullable=True)
    mtl_s2 = Column(String(10), nullable=True)
    mtp1_t1 = Column(String(10), nullable=True)
    mtp1_s1 = Column(String(10), nullable=True)
    mtp1_t2 = Column(String(10), nullable=True)
    mtp1_s2 = Column(String(10), nullable=True)
    mtp2_t1 = Column(String(10), nullable=True)
    mtp2_s1 = Column(String(10), nullable=True)
    mtp2_t2 = Column(String(10), nullable=True)
    mtp2_s2 = Column(String(10), nullable=True)
    mtp3_t1 = Column(String(10), nullable=True)
    mtp3_s1 = Column(String(10), nullable=True)
    mtp3_t2 = Column(String(10), nullable=True)
    mtp3_s2 = Column(String(10), nullable=True)
    mtp4_t1 = Column(String(10), nullable=True)
    mtp4_s1 = Column(String(10), nullable=True)
    mtp4_t2 = Column(String(10), nullable=True)
    mtp4_s2 = Column(String(10), nullable=True)
    mtp5_t1 = Column(String(10), nullable=True)
    mtp5_s1 = Column(String(10), nullable=True)
    mtp5_t2 = Column(String(10), nullable=True)
    mtp5_s2 = Column(String(10), nullable=True)
    r2ip1_t1 = Column(String(10), nullable=True)
    r2ip1_s1 = Column(String(10), nullable=True)
    r2ip1_t2 = Column(String(10), nullable=True)
    r2ip1_s2 = Column(String(10), nullable=True)
    r2ip2_t1 = Column(String(10), nullable=True)
    r2ip2_s1 = Column(String(10), nullable=True)
    r2ip2_t2 = Column(String(10), nullable=True)
    r2ip2_s2 = Column(String(10), nullable=True)
    ip3_t1 = Column(String(10), nullable=True)
    ip3_s1 = Column(String(10), nullable=True)
    ip3_t2 = Column(String(10), nullable=True)
    ip3_s2 = Column(String(10), nullable=True)
    ip4_t1 = Column(String(10), nullable=True)
    ip4_s1 = Column(String(10), nullable=True)
    ip4_t2 = Column(String(10), nullable=True)
    ip4_s2 = Column(String(10), nullable=True)
    ip5_t1 = Column(String(10), nullable=True)
    ip5_s1 = Column(String(10), nullable=True)
    ip5_t2 = Column(String(10), nullable=True)
    ip5_s2 = Column(String(10), nullable=True)
    s1_t1 = Column(String(10), nullable=True)
    s1_s1 = Column(String(10), nullable=True)
    s1_t2 = Column(String(10), nullable=True)
    s1_s2 = Column(String(10), nullable=True)

    # ROM

    cervical_anky = Column(String(10), nullable=True)
    cervical_flex = Column(String(10), nullable=True)
    cervical_ext = Column(String(10), nullable=True)
    cervical_rtrot = Column(String(10), nullable=True)
    cervical_ltrot = Column(String(10), nullable=True)
    cervical_rtfl = Column(String(10), nullable=True)
    cervical_ltfl = Column(String(10), nullable=True)
    cervical_pt = Column(String(10), nullable=True)
    thorasic_anky = Column(String(10), nullable=True)
    thorasic_flex = Column(String(10), nullable=True)
    thorasic_ext = Column(String(10), nullable=True)
    thorasic_rtrot = Column(String(10), nullable=True)
    thorasic_ltrot = Column(String(10), nullable=True)
    thorasic_rtfl = Column(String(10), nullable=True)
    thorasic_ltfl = Column(String(10), nullable=True)
    thorasic_pt = Column(String(10), nullable=True)
    lumbar_anky = Column(String(10), nullable=True)
    lumbar_flex = Column(String(10), nullable=True)
    lumbar_ext = Column(String(10), nullable=True)
    lumbar_rtrot = Column(String(10), nullable=True)
    lumbar_ltrot = Column(String(10), nullable=True)
    lumbar_rtfl = Column(String(10), nullable=True)
    lumbar_ltfl = Column(String(10), nullable=True)
    lumbar_pt = Column(String(10), nullable=True)

    # SOFT TISSUE RHEUMATISM
    opt_rt = Column(String(10), nullable=True)
    opt_lt = Column(String(10), nullable=True)
    lcer_rt = Column(String(10), nullable=True)
    lcer_lt = Column(String(10), nullable=True)
    trpz_rt = Column(String(10), nullable=True)
    trpz_lt = Column(String(10), nullable=True)
    scap_rt = Column(String(10), nullable=True)
    scap_lt = Column(String(10), nullable=True)
    zcst_rt = Column(String(10), nullable=True)
    zcst_lt = Column(String(10), nullable=True)
    epdl_rt = Column(String(10), nullable=True)
    epdl_lt = Column(String(10), nullable=True)
    glut_rt = Column(String(10), nullable=True)
    glut_lt = Column(String(10), nullable=True)
    trcr_rt = Column(String(10), nullable=True)
    trcr_lt = Column(String(10), nullable=True)
    knee_rt = Column(String(10), nullable=True)
    knee_lt = Column(String(10), nullable=True)
    ta_rt = Column(String(10), nullable=True)
    ta_lt = Column(String(10), nullable=True)
    calf_rt = Column(String(10), nullable=True)
    calf_lt = Column(String(10), nullable=True)
    sole_rt = Column(String(10), nullable=True)
    sole_lt = Column(String(10), nullable=True)
    # DEFORMITIES
    # joints

    rhand_fl = Column(String(10), nullable=True)
    rhand_ex = Column(String(10), nullable=True)
    rhand_ab = Column(String(10), nullable=True)
    rhand_add = Column(String(10), nullable=True)
    rhand_slx = Column(String(10), nullable=True)
    lhand_fl = Column(String(10), nullable=True)
    lhand_ex = Column(String(10), nullable=True)
    lhand_ab = Column(String(10), nullable=True)
    lhand_add = Column(String(10), nullable=True)
    lhand_slx = Column(String(10), nullable=True)
    rwrist_fl = Column(String(10), nullable=True)
    rwrist_ex = Column(String(10), nullable=True)
    rwrist_ab = Column(String(10), nullable=True)
    rwrist_add = Column(String(10), nullable=True)
    rwrist_slx = Column(String(10), nullable=True)
    lwrist_fl = Column(String(10), nullable=True)
    lwrist_ex = Column(String(10), nullable=True)
    lwrist_ab = Column(String(10), nullable=True)
    lwrist_add = Column(String(10), nullable=True)
    lwrist_slx = Column(String(10), nullable=True)
    relb_fl = Column(String(10), nullable=True)
    relb_ex = Column(String(10), nullable=True)
    relb_ab = Column(String(10), nullable=True)
    relb_add = Column(String(10), nullable=True)
    relb_slx = Column(String(10), nullable=True)
    lelb_fl = Column(String(10), nullable=True)
    lelb_ex = Column(String(10), nullable=True)
    lelb_ab = Column(String(10), nullable=True)
    lelb_add = Column(String(10), nullable=True)
    lelb_slx = Column(String(10), nullable=True)
    shrt_fl = Column(String(10), nullable=True)
    shrt_ex = Column(String(10), nullable=True)
    shrt_ab = Column(String(10), nullable=True)
    shrt_add = Column(String(10), nullable=True)
    shrt_slx = Column(String(10), nullable=True)
    shlt_fl = Column(String(10), nullable=True)
    shlt_ex = Column(String(10), nullable=True)
    shlt_ab = Column(String(10), nullable=True)
    shlt_add = Column(String(10), nullable=True)
    shlt_slx = Column(String(10), nullable=True)
    kneert_fl = Column(String(10), nullable=True)
    kneert_ex = Column(String(10), nullable=True)
    kneert_ab = Column(String(10), nullable=True)
    kneert_add = Column(String(10), nullable=True)
    kneert_slx = Column(String(10), nullable=True)
    kneelt_fl = Column(String(10), nullable=True)
    kneelt_ex = Column(String(10), nullable=True)
    kneelt_ab = Column(String(10), nullable=True)
    kneelt_add = Column(String(10), nullable=True)
    kneelt_slx = Column(String(10), nullable=True)
    footrt_fl = Column(String(10), nullable=True)
    footrt_ex = Column(String(10), nullable=True)
    footrt_ab = Column(String(10), nullable=True)
    footrt_add = Column(String(10), nullable=True)
    footrt_slx = Column(String(10), nullable=True)
    footlt_fl = Column(String(10), nullable=True)
    footlt_ex = Column(String(10), nullable=True)
    footlt_ab = Column(String(10), nullable=True)
    footlt_add = Column(String(10), nullable=True)
    footlt_slx = Column(String(10), nullable=True)

    # HYPERMOBILITY
    thumb_rt = Column(String(10), nullable=True)
    thumb_lt = Column(String(10), nullable=True)
    finger_rt = Column(String(10), nullable=True)
    finger_lt = Column(String(10), nullable=True)
    palm_rt = Column(String(10), nullable=True)
    palm_lt = Column(String(10), nullable=True)
    elbow_rt = Column(String(10), nullable=True)
    elbow_lt = Column(String(10), nullable=True)
    hy_knee_rt = Column(String(10), nullable=True)
    hy_knee_lt = Column(String(10), nullable=True)
    ankle_rt = Column(String(10), nullable=True)
    ankle_lt = Column(String(10), nullable=True)
    other_rt = Column(String(10), nullable=True)
    other_lt = Column(String(10), nullable=True)
    spine_rt = Column(String(10), nullable=True)
    spine_lt = Column(String(10), nullable=True)

    # HEALTH_ASSESSMENT_QUESTIONNAIRE :
    # are you able to….
    # dressing
    can_u_dress_urself = Column(String(10), nullable=True)
    can_u_wash_ur_hair = Column(String(10), nullable=True)
    can_u_comb_ur_hair = Column(String(10), nullable=True)
    dressing_score = Column(Integer, nullable=True)
    # arising
    can_u_stand_from_chair = Column(String(10), nullable=True)
    can_u_get_inout_from_bed = Column(String(10), nullable=True)
    can_u_sit_grossteg_onfloor = Column(String(10), nullable=True)
    arising_score = Column(Integer, nullable=True)
    # eating
    can_u_cut_vegetables = Column(String(10), nullable=True)
    can_u_lift_glass = Column(String(10), nullable=True)
    can_u_break_roti_from_1hand = Column(String(10), nullable=True)
    eating_score = Column(Integer, nullable=True)
    # walking
    can_u_walk = Column(String(10), nullable=True)
    can_u_climb_5steps = Column(String(10), nullable=True)
    walking_score = Column(Integer, nullable=True)
    # hygiene
    can_u_take_bath = Column(String(10), nullable=True)
    can_u_wash_dry_urbody = Column(String(10), nullable=True)
    can_u_get_onoff_toilet = Column(String(10), nullable=True)
    hygiene_score = Column(Integer, nullable=True)
    # reaching
    can_u_weigh_2kg = Column(String(10), nullable=True)
    can_u_bend_and_pickcloths = Column(String(10), nullable=True)
    reaching_score = Column(Integer, nullable=True)
    # grip
    can_u_open_bottle = Column(String(10), nullable=True)
    can_u_turntaps_onoff = Column(String(10), nullable=True)
    can_u_open_latches = Column(String(10), nullable=True)
    grip_score = Column(Integer, nullable=True)
    # activities
    can_u_work_office_house = Column(String(10), nullable=True)
    can_u_run_errands = Column(String(10), nullable=True)
    can_u_get_inout_of_bus = Column(String(10), nullable=True)
    activities_score = Column(Integer, nullable=True)
    # modified CRD pune version HAQ score
    # on a scale of 10 cm
    patient_assessment_pain = Column(Integer, nullable=True)
    grip_strength_rt = Column(Integer, nullable=True)
    grip_strength_hg = Column(Integer, nullable=True)
    grip_strength_lt = Column(Integer, nullable=True)
    early_mrng_stiffness = Column(BigInteger, nullable=True)
    sleep = Column(String(20), nullable=True)
    general_health_assessment = Column(BigInteger, nullable=True)

    # below should be there dont delete
    user_id = Column(BigInteger, ForeignKey('users.id'))
    user = relationship("Users")
    # rheuma_id = Column(BigInteger, ForeignKey('RheumatologyPatient.id'))
    rheuma = relationship("RheumatologyPatient")

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)


class RAttachments(Base):
    __tablename__ = 'rheuma attachments'
    id = Column(BigInteger, primary_key=True)
    pid = Column(BigInteger, ForeignKey('RheumatologyPatient.pid'), nullable=False)
    patient = relationship("RheumatologyPatient", lazy='joined')
    attachment = Column(String(60), nullable=False)
    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)

class BAttachments(Base):
    __tablename__ = 'breast attachments'
    id = Column(BigInteger, primary_key=True)
    pid = Column(BigInteger, ForeignKey('BreastPatient.pid'),nullable=False)
    patient = relationship("BreastPatient", lazy='joined')
    attachment = Column(String(60), nullable=False)

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)

class RFollowAttachments(Base):
    __tablename__ = 'followup attachments'
    id = Column(BigInteger, primary_key=True)
    pid = Column(BigInteger, ForeignKey('RheumatologyFollowup.pid'),nullable=False)
    patient = relationship("RheumatologyFollowup", lazy='joined')
    attachment = Column(String(60), nullable=False)

    def __unicode__(self):
        return str(self.id)

    def __repr__(self):
        return str(self.id)


class RheumatologyFollowupSchema(ModelSchema):
    class Meta:
        model = RheumatologyFollowup
        include_fk = True

    user = fields.Nested(UsersSchema)
    rheuma = fields.Nested(RheumatologyPatientSchema)


class Rheumatologyattachmentschema(ModelSchema):
    class Meta:
        model = RAttachments
        include_fk = True

    patient = fields.Nested(RheumatologyPatientSchema)


class RheumatologyFollowattachmentschema(ModelSchema):
    class Meta:
        model = RFollowAttachments
        include_fk = True

    patient = fields.Nested(RheumatologyFollowupSchema)


class Breastattachmentschema(ModelSchema):
    class Meta:
        model = BAttachments
        include_fk = True

    patient = fields.Nested(BPatientSchema)



engine = create_engine('mysql+pymysql://{}:{}@{}:{}/{}'.format(config['DATABASE']['USERNAME'],config['DATABASE']['PASSWORD'],config['DATABASE']['IP'],config['DATABASE']['PORT'],config['DATABASE']['DB']))
Session = sessionmaker(bind=engine)
session = scoped_session(Session)

Base.metadata.create_all(engine)
